// globals

function loadMe(){

    alert("Welcome to ChromEdit. Remember to LOAD pages first, unless you want them overwritten."+
        "And you must restart for changes to take effect.")

}

function getTextareaText(tNodeID) {
    var tat = document.getElementById(tNodeID).value;
    return tat;
}

function setTextareaText(thetext,tNodeID) {
    document.getElementById(tNodeID).value= thetext
}

function getChromeDir(fileName)
{
    var p;
    var NSIFILE = Components.interfaces.nsIFile;
    var dirLocator = Components.classes["@mozilla.org/file/directory_service;1"]
            .getService(Components.interfaces.nsIProperties);
    var p = dirLocator.get("UChrm", NSIFILE).path;
    if ( ! /css$/i.test(fileName))
        p = dirLocator.get("ProfD", NSIFILE).path;
    return p;
}

function loadIt(fileName,targetNodeID,label) {
    var chromeDir = getChromeDir(fileName);
    var fName = fileName;

    // We need 2 instances of nsILocalFile
    // One for the directory, and one for the file
    var dirLocal = Components.classes["@mozilla.org/file/local;1"]
                           .createInstance(Components.interfaces.nsILocalFile);
    dirLocal.initWithPath(chromeDir);
    dirLocal.append(fName);

    var fileLocal = new File(dirLocal.path);

    document.getElementById(label).value = dirLocal.path;

    if (fileLocal.exists()) {
        fileLocal.open()
        var stuff=fileLocal.read()
        fileLocal.close()
        setTextareaText(stuff,targetNodeID);
    }
    else if (/css$/i.test(fName) ) { // && ! f.exists()

        fName = fName.replace('.css', '-example.css');

        fileLocal = new File(fileLocal.path.replace(fileName, fName));

        if (fileLocal.exists()) {
            fileLocal.open()
            var stuff=fileLocal.read()
            fileLocal.close()
            setTextareaText(stuff,targetNodeID);
        }

    }
    else {setTextareaText('// Currently you do not have a user.js file.',targetNodeID)}

}

function saveIfChanged() {

    if ( ! document.getElementById('save-chrome').hasAttribute('disabled') )
        saveIt('userChrome.css','editChrome');

    if ( ! document.getElementById('save-content').hasAttribute('disabled') )
        saveIt('userContent.css','editContent');

    if ( ! document.getElementById('save-js').hasAttribute('disabled') )
        saveIt('user.js','editJs');

}

function saveIt(fileName,targetNodeID,button) {
    var data = getTextareaText(targetNodeID);

    var chromeDir = getChromeDir(fileName);
    var fName = fileName;

    // We need 2 instances of nsILocalFile
    // One for the directory, and one for the file
    var dirLocal = Components.classes["@mozilla.org/file/local;1"]
                           .createInstance(Components.interfaces.nsILocalFile);
    dirLocal.initWithPath(chromeDir);
    dirLocal.append(fName);

    var fileLocal = new File(dirLocal.path);

    fileLocal.open('w')
    var written = fileLocal.write(data)
    fileLocal.close()

    if(written)
        document.getElementById(button).setAttribute("disabled", "true");
}
